import type { Account } from "./account";
import type { CustomEmoji } from "./custom_emoji";

export default interface Activity {
	id: string;
	account: Account;
	akkoma?: ActivityAkkoma;
	created_at: string;

	content: string | null;
	spoiler_text: string | null;
	visibility: "public" | "unlisted" | "private" | "direct";
	mentions: Mention[];
	tags: Tag[];
	emojis: CustomEmoji[];

	reblogs_count: number;
	favourites_count: number;
	replies_count: number;
}

export interface ActivityContext {
	ancestors: Activity[];
	descendants: Activity[];
}

export interface ActivityAkkoma {
	source: ActivityAkkomaSource;
}

export interface ActivityAkkomaSource {
	content: string;
	mediaType: string;
}

export interface Mention {
	id: string;
	username: string;
	url: string;
	acct: string;
}

export interface Tag {
	name: string;
	url: string;
}
