import { watch, type Ref } from "vue";
import { useInstanceStore } from "../stores/instance";

const watchTitle = <T>(callback: (obj: T) => string | undefined, obj: Ref<T> | undefined = undefined) => {
	const instanceStore = useInstanceStore();
	if (obj) {
		watch(
			() => ({ obj: obj.value, instanceName: instanceStore.instanceName }),
			({ obj, instanceName }) => {
				const text = obj ? callback(obj) : undefined;
				document.title = text ? `${text} - ${instanceName}` : instanceName;
			},
			{ immediate: true },
		);
	} else {
		watch(
			() => instanceStore.instanceName,
			(name) => {
				document.title = name;
			},
			{ immediate: true },
		);
	}
};

export default watchTitle;
