import apiFetch from "@/lib/api-fetch";
import type Instance from "@/lib/api/entities/instance";
import { defineStore } from "pinia";

export const useInstanceStore = defineStore("instance", {
	state: () => ({
		instance: undefined as Instance | undefined,
	}),
	actions: {
		async fetchInstance() {
			const resp = await apiFetch<Instance>("/api/v1/instance");
			this.instance = resp;
		},
	},
	getters: {
		instanceName: (state) => state.instance?.title || "vulpine-fe",
	},
});
